<template>
	<q-infinite-scroll
		v-if="!loading"
		@load="handleNextPage"
		:offset="350"
		:disable="!scrollEnable || !urlApi"
	>
		<div class="row">
			<div
				class="col-12 col-sm-6 col-md-3"
				v-for="pokemon in pokemons"
				:key="pokemon.id"
			>
				<card-preview :pokemon="pokemon" class="q-ma-md" />
			</div>

			<div
				class="row col-12 items-center q-py-lg q-px-md"
				v-if="urlApi && !scrollEnable && pokemons.length"
			>
				<primary-button
					label="Load more pokemon"
					@click="handleNextPage"
					class="full-width text-bold"
					:loading="btnLoading"
				/>
			</div>

			<div
				class="row col-12 justify-center q-py-md"
				v-if="pokemons.length === totalPokemons"
			>
				<span class="text-primary text-bold text-h6"
					>End of Pokédex, Thank you</span
				>
			</div>
		</div>
		<template v-slot:loading>
			<div class="row justify-center q-my-md">
				<q-spinner-dots color="primary" size="120px" />
				<div class="text-bold text-dark text-h6 col-12 text-center">
					Capturing Pokémon, Please wait...
				</div>
			</div>
		</template>
	</q-infinite-scroll>
</template>

<script>
	import { mapActions, mapGetters, mapMutations, mapState } from "vuex";
	import PrimaryButton from "src/components/form/primary-button.vue";
	import headerTitle from "src/components/typography/header-title.vue";
	import CardPreview from "src/components/pokemon/CardPreview.vue";
	export default {
		name: "ScrollViewing",
		components: {
			headerTitle,
			CardPreview,
			PrimaryButton,
		},

		data: () => ({
			btnLoading: false,
			scrollEnable: false,
		}),
		methods: {
			...mapActions("pokemon", ["fetchData"]),
			...mapMutations("pokemon", ["toggleLoading"]),
			async handleNextPage(index, done) {
				if (this.urlApi) {
					this.btnLoading = true;
					await this.fetchData();
					this.btnLoading = false;
					this.scrollEnable = true;
					if (done) done();
				}
			},
		},

		computed: {
			...mapGetters("pokemon", ["pokemons"]),
			...mapState("pokemon", ["urlApi", "totalPokemons", "loading"]),
		},
	};
</script>

<style>
</style>